package be.iminds.ilabt.jfed.experimenter_gui.canvas.impl;

import be.iminds.ilabt.jfed.experimenter_gui.JFedConfiguration;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.ExperimentCanvas;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.TestbedAwareCanvasNode;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.highlevel.model.AuthorityList;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXRspecChannel;
import javafx.scene.image.Image;

/**
 * User: twalcari
 * Date: 4/23/2015
 * Time: 15:21
 */
public class RspecChannelCanvasNode extends TestbedAwareCanvasNode {

    private final FXRspecChannel channel;

    public RspecChannelCanvasNode(FXRspecChannel channel, ExperimentCanvas experimentCanvas, AuthorityList authorityList, JFedConfiguration config) {
        super(experimentCanvas, channel.getComponentName(),
                new Image(ImageUtil.class.getResource("/images/wireless-channel.png").toExternalForm())
                , authorityList, config);
        this.channel = channel;

        textProperty().bind(channel.componentNameProperty());

        layoutXProperty().bindBidirectional(channel.editorXProperty());
        layoutYProperty().bindBidirectional(channel.editorYProperty());

        experimentCanvas.getCanvas().getChildren().add(this);

        componentManagerId.bind(channel.componentManagerIdProperty());
    }

    public FXRspecChannel getChannel() {
        return channel;
    }

    /**
     * Should be called when the RspecCanvasLink is removed from the canvas
     */
    public void remove() {
        experimentCanvas.getCanvas().getChildren().remove(this);
    }
}
