package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.ExperimentController;
import be.iminds.ilabt.jfed.highlevel.controller.HighLevelController;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.highlevel.model.Sliver;

/**
 * User: twalcari
 * Date: 2/4/2015
 * Time: 09:41
 */
public class ReloadOSTask extends SingleCallExperimentTask {
    public static final int INITIAL_WAIT_MILLIS = 10_000;

    private final Sliver sliver;
    private final ExperimentController experimentController;
    private final ExperimentTasksFactory experimentTasksFactory;

    ReloadOSTask(ExperimentController experimentController, Sliver sliver, HighLevelController hlc, ExperimentTasksFactory experimentTasksFactory) {
        super(experimentController.getExperiment(), hlc);
        this.experimentController = experimentController;
        this.sliver = sliver;
        this.experimentTasksFactory = experimentTasksFactory;

        updateTitle("ReloadOS sliver " + sliver.getUrn().toString());

    }

    @Override
    public Task createTask() {
        return hlc.getReloadOSTask(sliver);
    }


    @Override
    public void onTaskFinished(TaskExecution taskExecution) {
        if (taskExecution.getState() == TaskExecution.TaskState.SUCCESS) {
            experimentController.submitExperimentTask(experimentTasksFactory.createStatusUntilReadyTask(experiment, sliver.getAuthority(), INITIAL_WAIT_MILLIS));
        }
    }
}
