package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.Experiment;
import be.iminds.ilabt.jfed.experimenter_gui.slice.SliceState;
import be.iminds.ilabt.jfed.highlevel.controller.HighLevelController;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import javafx.application.Platform;

/**
 * User: twalcari
 * Date: 2/2/2015
 * Time: 17:24
 */
public class StopExperimentTask extends SingleCallExperimentTask {

    StopExperimentTask(Experiment experiment, HighLevelController hlc) {
        super(experiment, hlc);
        assert(experiment.getSlice() != null);

        updateTitle("Delete all active nodes from experiment '" + experiment.getName() + "'");
    }


    @Override
    public Task createTask() {
        return hlc.deleteSlice(experiment.getSlice());
    }


    @Override
    public void onTaskStarting() {
        Platform.runLater(() -> {
            experiment.setDeleting(true);
        });
    }


    @Override
    public void onTaskFinished(TaskExecution taskExecution) {
        if (taskExecution.getState() == TaskExecution.TaskState.SUCCESS) {
            assert (experiment.getExperimentRestoreInformation() != null);
            experiment.getExperimentRestoreInformation().delete();
            experiment.setSliceState(SliceState.EXPIRED_OR_EMPTY);
        } else {
            //deletion failed!
            experiment.setDeleting(false);
        }
    }
}
