package be.iminds.ilabt.jfed.highlevel.stitcher;

import be.iminds.ilabt.jfed.call_log_output.CallReport;
import be.iminds.ilabt.jfed.log.cache.ApiCallDetailsCache;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.util.Collection;

/**
 * User: twalcari
 * Date: 4/3/2015
 * Time: 14:31
 */
@Singleton
public class StitchingReportFactory {

    private final ApiCallDetailsCache cache;

    @Inject
    public StitchingReportFactory(ApiCallDetailsCache cache) {
        this.cache = cache;
    }

    public StitchingReport createStitchingReport() {
        return new StitchingReport(cache);
    }

    public StitchingReport createStitchingReport(String initialStateName) {
        return new StitchingReport(initialStateName, cache);
    }

    public StitchingReport createStitchingReport(Collection<CallReport.State> states) {
        return new StitchingReport(states, cache);
    }
}
