package be.iminds.ilabt.jfed.rspec.model;

import org.testng.annotations.Test;

import java.util.List;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertNotNull;
import static org.testng.Assert.assertNull;

/**
 * BasicStringRspecTest
 */
public class BasicStringRspecTest {
    private static final String wall2Manifest =
            "<rspec xmlns=\"http://www.geni.net/resources/rspec/3\" xmlns:client=\"http://www.protogeni.net/resources/rspec/ext/client/1\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" type=\"manifest\" xsi:schemaLocation=\"http://www.geni.net/resources/rspec/3 http://www.geni.net/resources/rspec/3/manifest.xsd \" expires=\"2014-09-01T06:15:12Z\">\n  " +
                    "   <node client_id=\"PC\" component_manager_id=\"urn:publicid:IDN+wall2.ilabt.iminds.be+authority+cm\" exclusive=\"true\" component_id=\"urn:publicid:IDN+wall2.ilabt.iminds.be+node+n091-25\" sliver_id=\"urn:publicid:IDN+wall2.ilabt.iminds.be+sliver+28109\">\n" +
                    "      <sliver_type name=\"raw-pc\"/>\n" +
                    "      <rs:vnode xmlns:rs=\"http://www.protogeni.net/resources/rspec/ext/emulab/1\" name=\"n091-25\"/><host name=\"PC.sTKe1409551752.ch-geni-net.wall2.ilabt.iminds.be\"/>" +
                    "      <services><login authentication=\"ssh-keys\" hostname=\"n091-25.wall2.ilabt.iminds.be\" port=\"22\" username=\"wimvande\"/></services>" +
                    "   </node>\n" +
                    "</rspec>";
    private static final String wall2ManifestWithProxy =
            "<rspec xmlns=\"http://www.geni.net/resources/rspec/3\" xmlns:client=\"http://www.protogeni.net/resources/rspec/ext/client/1\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" type=\"manifest\" " +
                    "        xmlns:sshproxy=\"http://jfed.iminds.be/proxy/1.0\" " +
                    "        xsi:schemaLocation=\"http://www.geni.net/resources/rspec/3 http://www.geni.net/resources/rspec/3/manifest.xsd \" expires=\"2014-09-01T06:15:12Z\">\n  " +
                    "   <node client_id=\"PC\" component_manager_id=\"urn:publicid:IDN+wall2.ilabt.iminds.be+authority+cm\" exclusive=\"true\" component_id=\"urn:publicid:IDN+wall2.ilabt.iminds.be+node+n091-25\" sliver_id=\"urn:publicid:IDN+wall2.ilabt.iminds.be+sliver+28109\">\n" +
                    "      <sliver_type name=\"raw-pc\"/>\n" +
                    "      <rs:vnode xmlns:rs=\"http://www.protogeni.net/resources/rspec/ext/emulab/1\" name=\"n091-25\"/><host name=\"PC.sTKe1409551752.ch-geni-net.wall2.ilabt.iminds.be\"/>" +
                    "      <services>\n" +
                    "         <sshproxy:proxy proxy=\"wvdemeer@bastion.test.iminds.be:22\" for=\"wimvande@n091-25.wall2.ilabt.iminds.be:22\"/>\n"+
                    "         <login authentication=\"ssh-keys\" hostname=\"n091-25.wall2.ilabt.iminds.be\" port=\"22\" username=\"wimvande\"/>\n" +
                    "      </services>" +
                    "   </node>\n" +
                    "</rspec>";
    private static final String bonfireManifestWithProxy = "<?xml version='1.0' encoding='UTF-8'?>" +
            "<rspec xmlns=\"http://www.geni.net/resources/rspec/3\"" +
            "       xmlns:bonfire=\"http://doc.bonfire-project.eu/schemas/rspec/ext/bonfire/1\" " +
            "       xmlns:occi=\"http://api.bonfire-project.eu/doc/schemas/occi\" " +
            "       expires=\"2015-09-24 21:12:33.776450+00:00\" " +
            "       generated=\"2015-09-24 21:12:33.776450+00:00\" " +
            "       type=\"manifest\" " +
            "       xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
            "       xsi:schemaLocation=\"http://www.geni.net/resources/rspec/3 http://www.geni.net/resources/rspec/3/ad\">" +
            "   <bonfire:reservation sliver_id=\"urn:publicid:IDN+sfa.dev.bonfire.eu+sliver+%2Freservations%2F30\">" +
            "      <occi:expires_at>2015-09-24 21:21:06 UTC</occi:expires_at> " +
            "      <occi:starttime>2015-09-24 21:11:09 UTC</occi:starttime> " +
            "      <occi:walltime>1196</occi:walltime> " +
            "      <occi:groups>ftester</occi:groups> " +
            "      <occi:status>Running</occi:status> " +
            "   </bonfire:reservation>" +
            "      <node client_id=\"node0\" component_id=\"urn:publicid:IDN+sfa.dev.bonfire.eu+node+%2Flocations%2Ffr-inria%2Fcomputes%2F31405\" " +
            "            component_manager_id=\"urn:publicid:IDN+sfa.dev.bonfire.eu:fr-inria+authority+am\" " +
            "            component_name=\"node0\" exclusive=\"false\" " +
            "            sliver_id=\"urn:publicid:IDN+sfa.dev.bonfire.eu+sliver+%2Flocations%2Ffr-inria%2Fcomputes%2F31405\">" +
            "         <occi:context> " +
            "              <occi:authorized_keys>ssh-rsa AAAAB3NzaCblabla==</occi:authorized_keys> " +
            "              <occi:bonfire_experiment_aggregator_password>mjj5vk</occi:bonfire_experiment_aggregator_password> " +
            "              <occi:bonfire_experiment_expiration_date>1443129604</occi:bonfire_experiment_expiration_date> " +
            "              <occi:bonfire_experiment_id>56398</occi:bonfire_experiment_id> " +
            "               <occi:bonfire_experiment_routing_key>a50c6be49d2ab1b057f8</occi:bonfire_experiment_routing_key> " +
            "               <occi:bonfire_provider>fr-inria</occi:bonfire_provider> " +
            "               <occi:bonfire_resource_id>31405</occi:bonfire_resource_id> " +
            "               <occi:bonfire_resource_name>node0</occi:bonfire_resource_name> " +
            "               <occi:bonfire_uri>https://api.integration.bonfire.grid5000.fr</occi:bonfire_uri> " +
            "               <occi:cluster>default</occi:cluster> <occi:dns_domain>experiments.integration.bonfire.internal</occi:dns_domain> " +
            "               <occi:dns_search>experiments.integration.bonfire.internal fr-inria.bonfire.internal</occi:dns_search> " +
            "               <occi:dns_servers>172.18.1.36</occi:dns_servers> " +
            "               <occi:files>/srv/cloud/context/lib /srv/cloud/context/distributions /srv/cloud/context/sites /srv/cloud/context/common /srv/cloud/context/init.sh</occi:files> " +
            "               <occi:group>ftester</occi:group> " +
            "               <occi:host>node-1.integration.bonfire.grid5000.fr</occi:host> " +
            "               <occi:hostname>node0</occi:hostname> " +
            "               <occi:log>http://frontend.integration.bonfire.grid5000.fr/logs/31405.log</occi:log> " +
            "               <occi:ntp_servers>ntp1.irisa.fr</occi:ntp_servers> " +
            "               <occi:public_gateway>131.254.204.8</occi:public_gateway>" +
            "               <occi:target>xvdb</occi:target>" +
            "               <occi:v6_gw>2001:660:7303:204::1</occi:v6_gw> " +
            "               <occi:v6_prefix>2001:660:7303:204</occi:v6_prefix> " +
            "               <occi:wan_gateway>172.18.7.1</occi:wan_gateway> " +
            "               <occi:wan_ip>172.18.7.222</occi:wan_ip> " +
            "               <occi:wan_mac>02:00:ac:12:07:de</occi:wan_mac> " +
            "         </occi:context>" +
            "         <occi:host>node-1.integration.bonfire.grid5000.fr</occi:host>" +
            "         <occi:name>node0</occi:name> " +
            "         <occi:cpu>0.25</occi:cpu> " +
            "         <occi:memory>394</occi:memory> " +
            "         <occi:instance_type href=\"/locations/fr-inria/configurations/custom\">custom</occi:instance_type> " +
            "         <occi:state>running</occi:state> " +
            "         <occi:disk id=\"0\"> " +
            "            <occi:storage href=\"/locations/fr-inria/storages/1391\" name=\"BonFIRE Debian Squeeze 2G v6\" /> " +
            "            <occi:type>FILE</occi:type> " +
            "            <occi:target>xvda</occi:target> </occi:disk> " +
            "            <occi:nic> " +
            "               <occi:network href=\"/locations/fr-inria/networks/1\" name=\"BonFIRE WAN\" /> " +
            "               <occi:ip>172.18.7.222</occi:ip> " +
            "               <occi:mac>02:00:ac:12:07:de</occi:mac> " +
            "            </occi:nic> " +
            "         <sliver_type name=\"VM\" />" +
            "         <services xmlns:bonfire=\"https://www.bonfire-project.eu/rspecs/bonfire/1.0\" xmlns:ns=\"http://jfed.iminds.be/proxy/1.0\">" +
            "            <login authentication=\"ssh-keys\" hostname=\"ssh.fr-inria.bonfire-project.eu\" port=\"22\" username=\"ftester\" />" +
            "            <login authentication=\"ssh-keys\" hostname=\"172.18.7.222\" port=\"22\" username=\"root\" />" +
            "            <ns:proxy for=\"root@172.18.7.222\" proxy=\"ftester@ssh.fr-inria.bonfire-project.eu\" />" +
            "            <bonfire:frcp server=\"amqp.fed4fire.eu\" type=\"XMPP\" xmpp_topic=\"node0.56398.experiments.production.bonfire.internal\" />" +
            "            <bonfire:notifications routing_key=\"a50c6be49d2ab1b057f8\" server=\"mq.bonfire-project.eu\" type=\"AMQP\" />" +
            "         </services>" +
            "         <host name=\"node0\" />" +
            "         <hardware name=\"node-1.integration.bonfire.grid5000.fr\" />" +
            "      </node>" +
            "</rspec>";

    public static final String helloGeniRspec = "<!--\n" +
            "Copyright (c) 2010-2015 Raytheon BBN Technologies\n" +
            "\n" +
            "Permission is hereby granted, free of charge, to any person obtaining\n" +
            "a copy of this software and/or hardware specification (the \"Work\") to\n" +
            "deal in the Work without restriction, including without limitation the\n" +
            "rights to use, copy, modify, merge, publish, distribute, sublicense,\n" +
            "and/or sell copies of the Work, and to permit persons to whom the Work\n" +
            "is furnished to do so, subject to the following conditions:\n" +
            "\n" +
            "The above copyright notice and this permission notice shall be\n" +
            "included in all copies or substantial portions of the Work.\n" +
            "\n" +
            "THE WORK IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS\n" +
            "OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\n" +
            "MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\n" +
            "NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT\n" +
            "HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,\n" +
            "WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n" +
            "OUT OF OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS\n" +
            "IN THE WORK.\n" +
            "-->\n" +
            "\n" +
            "<rspec xmlns=\"http://www.geni.net/resources/rspec/3\"  \n" +
            "       xmlns:emulab=\"http://www.protogeni.net/resources/rspec/ext/emulab/1\" \n" +
            "       xmlns:tour=\"http://www.protogeni.net/resources/rspec/ext/apt-tour/1\" \n" +
            "       xmlns:jacks=\"http://www.protogeni.net/resources/rspec/ext/jacks/1\"\n" +
            "       xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" +
            "       xsi:schemaLocation=\"http://www.geni.net/resources/rspec/3    http://www.geni.net/resources/rspec/3/request.xsd\" \n" +
            "       type=\"request\">\n" +
            "\n" +
            " <node xmlns:rs=\"http://www.protogeni.net/resources/rspec/ext/emulab/1\" client_id=\"server\" exclusive=\"false\">\n" +
            "    <sliver_type name=\"default-vm\"/>\n" +
            "    <emulab:routable_control_ip xmlns:emulab=\"http://www.protogeni.net/resources/rspec/ext/emulab/1\"/>\n" +
            "    <services>\n" +
            "      <install install_path=\"/local\" url=\"http://www.gpolab.bbn.com/experiment-support/HelloGENI//hellogeni-install.tar.gz\"/>\n" +
            "      <execute command=\"sudo /local/install-script.sh\" shell=\"sh\"/>\n" +
            "    </services>\n" +
            "    <interface client_id=\"server:if0\">\n" +
            "       <ip xmlns=\"http://www.geni.net/resources/rspec/3\" address=\"10.10.10.1\" type=\"ipv4\" netmask=\"255.255.255.0\"/>\n" +
            "     </interface>\n" +
            "    <site xmlns=\"http://www.protogeni.net/resources/rspec/ext/jacks/1\" id=\"28\"/>\n" +
            "  </node>\n" +
            "  \n" +
            "  <node xmlns:rs=\"http://www.protogeni.net/resources/rspec/ext/emulab/1\" client_id=\"client\" exclusive=\"false\">\n" +
            "    <sliver_type name=\"default-vm\"/>\n" +
            "    <services>  \n" +
            "      <install install_path=\"/local\" url=\"http://www.gpolab.bbn.com/experiment-support/HelloGENI//hellogeni-install.tar.gz\"/>\n" +
            "      <execute command=\"sudo /local/install-script.sh\" shell=\"sh\"/>\n" +
            "    </services>\n" +
            "    <interface client_id=\"client:if0\">\n" +
            "      <ip xmlns=\"http://www.geni.net/resources/rspec/3\" address=\"10.10.10.2\" type=\"ipv4\" netmask=\"255.255.255.0\"/>\n" +
            "    </interface>\n" +
            "    <site xmlns=\"http://www.protogeni.net/resources/rspec/ext/jacks/1\" id=\"28\"/>\n" +
            "  </node>\n" +
            "\n" +
            "  <link client_id=\"lan0\">\n" +
            "    <interface_ref client_id=\"server:if0\"/>\n" +
            "    <interface_ref client_id=\"client:if0\"/>\n" +
            "    <property source_id=\"server:if0\" dest_id=\"client:if0\"/>\n" +
            "    <property source_id=\"client:if0\" dest_id=\"server:if0\"/>\n" +
            "    <link_type name=\"lan\"/>\n" +
            "  </link>\n" +
            "\n" +
            "</rspec>\n";

    @Test
    public void testWall2Manifest() {
        BasicStringRspec basicStringRspec = new BasicStringRspec(wall2Manifest);

        List<BasicStringRspec.BasicNodeInfo> basicNodeInfos = basicStringRspec.getBasicNodeInfo();
        assertEquals(basicNodeInfos.size(), 1);
        BasicStringRspec.BasicNodeInfo node0 = basicNodeInfos.get(0);
        assertNotNull(node0.getClientId());
        assertNotNull(node0.getComponentId());
        assertEquals(node0.getClientId(), "PC");
        assertEquals(node0.getComponentId(), "urn:publicid:IDN+wall2.ilabt.iminds.be+node+n091-25");
        assertEquals(node0.getComponentManagerId(), "urn:publicid:IDN+wall2.ilabt.iminds.be+authority+cm");
        assertEquals(node0.getUniqueId(), "PC@urn:publicid:IDN+wall2.ilabt.iminds.be+authority+cm");

        List<BasicStringRspec.LoginService> loginServiceList = basicStringRspec.findNodeLoginInfoByUniqueId(
                node0.getUniqueId());
        assertEquals(loginServiceList.size(), 1);
        BasicStringRspec.LoginService login = loginServiceList.get(0);
        assertEquals(login.getAuthentication(), "ssh-keys");
        assertEquals(login.getHostname(), "n091-25.wall2.ilabt.iminds.be");
        assertEquals(login.getPort(), 22);
        assertEquals(login.getUsername(), "wimvande");
        assertNull(login.getSshProxy());
    }
    @Test
    public void testWall2ManifestWithProxy() {
        BasicStringRspec basicStringRspec = new BasicStringRspec(wall2ManifestWithProxy);

        List<BasicStringRspec.BasicNodeInfo> basicNodeInfos = basicStringRspec.getBasicNodeInfo();
        assertEquals(basicNodeInfos.size(), 1);
        BasicStringRspec.BasicNodeInfo node0 = basicNodeInfos.get(0);
        assertNotNull(node0.getClientId());
        assertNotNull(node0.getComponentId());
        assertEquals(node0.getClientId(), "PC");
        assertEquals(node0.getComponentId(), "urn:publicid:IDN+wall2.ilabt.iminds.be+node+n091-25");
        assertEquals(node0.getComponentManagerId(), "urn:publicid:IDN+wall2.ilabt.iminds.be+authority+cm");
        assertEquals(node0.getUniqueId(), "PC@urn:publicid:IDN+wall2.ilabt.iminds.be+authority+cm");

        List<BasicStringRspec.LoginService> loginServiceList = basicStringRspec.findNodeLoginInfoByUniqueId(
                node0.getUniqueId());
        assertEquals(loginServiceList.size(), 1);
        BasicStringRspec.LoginService login = loginServiceList.get(0);
        assertEquals(login.getAuthentication(), "ssh-keys");
        assertEquals(login.getHostname(), "n091-25.wall2.ilabt.iminds.be");
        assertEquals(login.getPort(), 22);
        assertEquals(login.getUsername(), "wimvande");
        assertNotNull(login.getSshProxy());
        assertEquals(login.getSshProxy().getUsername(), "wvdemeer");
        assertEquals(login.getSshProxy().getHostname(), "bastion.test.iminds.be");
        assertEquals(login.getSshProxy().getPort(), 22);
        assertNull(login.getSshProxy().getHostKey());
        assertNull(login.getSshProxy().getSshKeyInfo());
    }
    @Test
    public void testBonfireManifestWithProxy() {
        BasicStringRspec basicStringRspec = new BasicStringRspec(bonfireManifestWithProxy);

        List<BasicStringRspec.BasicNodeInfo> basicNodeInfos = basicStringRspec.getBasicNodeInfo();
        assertEquals(basicNodeInfos.size(), 1);
        BasicStringRspec.BasicNodeInfo node0 = basicNodeInfos.get(0);
        assertNotNull(node0.getClientId());
        assertNotNull(node0.getComponentId());
        assertEquals(node0.getClientId(), "node0");
        assertEquals(node0.getComponentId(), "urn:publicid:IDN+sfa.dev.bonfire.eu+node+%2Flocations%2Ffr-inria%2Fcomputes%2F31405");
        assertEquals(node0.getComponentManagerId(), "urn:publicid:IDN+sfa.dev.bonfire.eu:fr-inria+authority+am");
        assertEquals(node0.getUniqueId(), "node0@urn:publicid:IDN+sfa.dev.bonfire.eu:fr-inria+authority+am");

        List<BasicStringRspec.LoginService> loginServiceList = basicStringRspec.findNodeLoginInfoByUniqueId(
                node0.getUniqueId());
        assertEquals(loginServiceList.size(), 2);
        BasicStringRspec.LoginService login = loginServiceList.get(0);
        assertEquals(login.getAuthentication(), "ssh-keys");
        assertEquals(login.getHostname(), "ssh.fr-inria.bonfire-project.eu");
        assertEquals(login.getPort(), 22);
        assertEquals(login.getUsername(), "ftester");
        assertNull(login.getSshProxy());

        login = loginServiceList.get(1);
        assertEquals(login.getAuthentication(), "ssh-keys");
        assertEquals(login.getHostname(), "172.18.7.222");
        assertEquals(login.getPort(), 22);
        assertEquals(login.getUsername(), "root");
        assertNotNull(login.getSshProxy());
        assertEquals(login.getSshProxy().getUsername(), "ftester");
        assertEquals(login.getSshProxy().getHostname(), "ssh.fr-inria.bonfire-project.eu");
        assertEquals(login.getSshProxy().getPort(), 22);
        assertNull(login.getSshProxy().getHostKey());
        assertNull(login.getSshProxy().getSshKeyInfo());
    }
    @Test
    public void testHelloGeni() {
        BasicStringRspec basicStringRspec = new BasicStringRspec(helloGeniRspec);

        List<BasicStringRspec.BasicNodeInfo> basicNodeInfos = basicStringRspec.getBasicNodeInfo();
        assertEquals(basicNodeInfos.size(), 2);
        BasicStringRspec.BasicNodeInfo node0 = basicNodeInfos.get(0);
        assertNotNull(node0.getClientId());
        assertNull(node0.getComponentId());
        assertNull(node0.getComponentManagerId());

        assertEquals(basicStringRspec.getAllComponentManagerUrns().size(), 0);
    }
}
